parameters jak
 *prepares output, processes statist.dbf files
 *jak - 997   - checking the file for temperature indices,  998  for precipitation

 *jak - 1   - yearly values,  0 - periods  (for statist*.dbf files)
  *jak - 5   - yearly values,  6 - periods  (for statist*.dbf files, indice 48, 51, 53,55, 57,75)
 *jak - 3   - yearly values,  4 - periods  (for nodays*.dbf files)
 *jak - 7    (for monthly values)

 *jak- 100 - adjust days periods  for basic statistics calculation  -   rounding towards the later period (CECILIA WP4 DELIVERABLE D4.1)
   *jak - 101 - i48 - joining months, seasons, year
           *into x_orig saves original series,  and replaces months with: x_monthly, and seasons with x_seasonal values, thus leaves only Year
 *jak - 200 - adjust statistics - to take only annual values for number of days - specified limits, I79-89
 *jak - 90  - to fill 0 for each month, this is part of No_days - Periods,  but for indice i57 it has to be calculated here ...


 SET PROCEDURE TO controls\programs\mojeproc1 additive

	
*debug
*suspend
*messagebox(transform(jak))


if (jak=997)or(jak=998)
  *check ID,
  if not(Column_exist('ID'))
MESSAGEBOX("Column 'ID' not found!",0+16,"Missing column",10*1000)
  else
    locate for atc('_',ID)>0
    if FOUND()
	if MESSAGEBOX("Column 'ID' should be free of character '_' for further processing!"+CHR(13)+CHR(10)+;
	           "Do you want to replace it with charecter '-' ?",1+16,"Missing column",10*1000)=1
	  replace ID WITH STRTRAN(ID,'_','-') all			                             
	  BROWSE 
	endif
    endif
  endif
  if not(Column_exist('Element'))
MESSAGEBOX("Column 'Element' not found!",0+16,"Missing column",10*1000)
  else
    if (jak=998)
     locate for upper(alltrim(Element))='SRA'
     if not(found())
MESSAGEBOX("Column 'Element' should contain: 'SRA' !",0+16,"Missing value",10*1000)
     endif
    endif
    if (jak=997)
     locate for upper(alltrim(Element))='T'
     if not(found())
MESSAGEBOX("Column 'Element' should contain: 'T' !",0+16,"Missing value",10*1000)
     endif
     locate for upper(alltrim(Element))='TMA'
     if not(found())
MESSAGEBOX("Column 'Element' should contain: 'TMA' !",0+16,"Missing value",10*1000)
     endif
     locate for upper(alltrim(Element))='TMI'
     if not(found())
MESSAGEBOX("Column 'Element' should contain: 'TMI' !",0+16,"Missing value",10*1000)
     endif
    endif
  endif
RETURN
endif



if (jak<100)
 if Column_exist('n1x')
   if COlumn_exist('n1')
     alter table dbf() drop column n1
   endif
  alter table dbf() rename column n1x to n1
 endif
 if Column_exist('k1x')
   if COlumn_exist('k1')
     alter table dbf() drop column k1
   endif
  alter table dbf() rename column k1x to k1                                                                     
 endif
endif



if (jak=1)or(jak=0)

 if jak=1
    if Not(Column_Exist('year'))
  alter table dbf() add column year N(4)
    endif 
  replace year with year(begin) all
  Change_columns_order('year',Column_Exist2('k1'))   
 * Alter table dbf() drop column begin drop column end   &&ZDE NEDELANE
 endif

 alter table dbf() drop column begin drop column end


 alter table dbf() drop column remark drop column alt_1 drop column alt_2 drop column length
 alter table dbf() drop column all_months


 alter table dbf() rename column ID_1 to ID

 replace id with strextr(id,'','_') all for atc('_',id)>0

endif




if (jak=3)or(jak=4)

 if not(column_exist('region'))
   alter table dbf() add column region C(3)
 endif
 Change_columns_order('Region',Column_Exist2('year'))   

 if jak=4
  alter table dbf() drop column year
 endif

   if (Column_exist('n13'))and(not(COlumn_exist('n_year')))
 alter table dbf() rename column n13 to n_year
   endif
   if (Column_exist('n13'))
 alter table dbf() drop column n13
   endif


   replace id with alltrim(strtran(id,'__','_')) all  &&protoze iD je slozenina take zprazdneho Remark, takze je to tam navic
 replace Region with  alltrim(strextr(id,'_','')) all

 replace id with strextr(id,'','_') all for atc('_',id)>0

endif






if (jak=5)or(jak=6)

 if jak=5
    if Not(Column_Exist('year'))
  alter table dbf() add column year N(4)
    endif
  replace year with year(begin) all
  Change_columns_order('year',Column_Exist2('k1'))   
  alter table dbf() drop column remark   &&<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 else
    *periods
     if (type('begin')='D')
  replace Remark with transform(year(begin))+'-'+transform(year(end)) ALL
     else
  replace Remark with transform((begin))+'-'+transform((end)) ALL
     endif
 endif


  Alter table dbf() drop column begin drop column end  

 alter table dbf() drop column alt_1 drop column alt_2 drop column length  
 alter table dbf() drop column all_months

   if Column_exist('k13')
 alter table dbf() drop column k13
   endif
   if Column_exist('n13')
 alter table dbf() drop column n13
   endif
   if Column_exist('no_cases')
 alter table dbf() drop column no_cases
   endif
  

 alter table dbf() rename column ID_1 to ID

   replace id with alltrim(strtran(id,'__','_')) all  &&protoze iD je slozenina take zprazdneho Remark, takze je to tam navic
      if Column_exist('Region')
 replace Region with  alltrim(strextr(id,'_','')) all
      endif

 replace id with strextr(id,'','_') all for atc('_',id)>0

endif





if (jak=7)
 alter table dbf() drop column rem drop column remark
  if Column_exist('n13')
 alter table dbf() drop column n13
  endif
 alter table dbf() drop column element 
endif





if (jak=100)
* alter table dbf() rename column no_days to Value2                                                                     
* alter table dbf() drop column values_avg;  alter table dbf() drop column values_sum                                   
* alter table dbf() drop column val_sum_ef; alter table dbf() drop column remark                         
*   *middle of begin-end period <<<               
* replace end_date with date(year,month,day)+int((end_date-date(year,month,day))/2) all for year>0                      
* replace year with year(end_date) all;replace month with month(end_date) all;                                          
* replace day with day(end_date) all                                                                                    

 alter table dbf() rename column no_days to Value2                                                                     
    if Column_exist('values_avg')
 alter table dbf() drop column values_avg
    endif
    if Column_exist('values_sum')
  alter table dbf() drop column values_sum                                   
    endif
    if Column_exist('val_sum_ef')
 alter table dbf() drop column val_sum_ef
    endif
 alter table dbf() drop column remark     

 
*For medians and maxima of spell lengths, any spell crossing a period boundary is allocated to the mid day with rounding towards the later period (CECILIA WP4 DELIVERABLE D4.1)

     IF Column_exist('Year')                    
   *middle of begin-end period <<<               
*OLD replace end_date with date(year,month,day)+int((end_date-date(year,month,day))/2) all for year>0

  replace end_date with date(year,month,day)+CEILING((end_date-date(year,month,day))/2) all for year>0                      
		 replace year with year(end_date) all
		  replace month with month(end_date) all                                          
		 replace day with day(end_date) all                                                                                    
     ELSE

*OLD replace end_date with Date+int((end_date-Date)/2) all for YEAR(Date)>0                      
 replace end_date with Date+CEILING((end_date-Date)/2) all for YEAR(Date)>0                      
		 replace Date WITH end_date all

     ENDIF     

endif





    *into x_orig saves original series,  and replaces months with: x_monthly, and seasons with x_seasonal values, thus leaves only Year
if (jak=101) 
 
 set safety off
IF not(USED())
RETURN -1
ENDIF

 x=(dbf())  &&FULLPATH     &&zde pouze rok
 sele_pom=select()
  x_orig=JUSTPATH(x)+'\'+JUSTstem(x)+'_orig'+'.'+justext(x)
 x_m=JUSTPATH(x)+'\'+JUSTstem(x)+'_monthly'+'.'+justext(x)
 x_s=JUSTPATH(x)+'\'+JUSTstem(x)+'_seasonally'+'.'+justext(x)

 x="'"+STRTRAN(x,"'","")+"'"
 x_orig="'"+STRTRAN(x_orig,"'","")+"'"
 x_m="'"+STRTRAN(x_m,"'","")+"'"
 x_s="'"+STRTRAN(x_s,"'","")+"'"

		*SELECT  id_1,id_2,region,begin,end,length,alt_1,remark,alt_2,all_month,k1,k2,k3,k4,k5,k6,k7,k8,k9,k10,k11,k12  FROM       'DATA\Cecilia\i48_statist_days_periods_0_1961-1990.dbf'

ss_pom=Get_columns_names()
   if (atc('k_year',ss_pom)>0)
ss_pom_m=substr(ss_pom,1,atc('k_year',ss_pom)-2)
   else 
  ss_pom_m=substr(ss_pom,1,atc('k12',ss_pom)+2)
   endif
ss_pom_s='k_djf,k_mam,k_jja,k_son'
ss_pom_y='k_year'
  ss_pom_m=Uprav_nazev_combine_ID_for_Select(ss_pom_m,'a.')
  ss_pom_y=Uprav_nazev_combine_ID_for_Select(ss_pom_y,'b.') &&zde pouze rok
  ss_pom_s=Uprav_nazev_combine_ID_for_Select(ss_pom_s,'c.')



*   if (file_exist(x))and(file_exist(x_m))and(file_exist(x_s))
 use
 copy file &x to &x_orig

SELECT  &ss_pom_m,&ss_pom_y,&ss_pom_s;
 FROM &x_m a LEFT OUTER JOIN &x_orig b ;
 ON (a.id_1=b.id_1)and(a.id_2=b.id_2)and(a.region=b.region)and(year(a.begin)=year(b.begin))and(year(a.end)=year(b.end));
 LEFT OUTER JOIN &x_s c ;
 ON (a.id_1=c.id_1)and(a.id_2=c.id_2)and(a.region=c.region)and(year(a.begin)=year(c.begin))and(year(a.end)=year(c.end));
 into table &x   

 use
 select(sele_pom)
 use &x
*   endif
 set safety off

endif  &&jak=101




**************************************




if (jak=200)
  if Column_exist('k_year')
 alter table dbf() rename column k_year to Value
   else 
 alter table dbf() rename column k13 to Value
  endif

 alter table dbf() drop column k1 drop column k2 drop column k3;
                   drop column k4 drop column k5 drop column k6;
                   drop column k7 drop column k8 drop column k9;
                   drop column k10 drop column k11 drop column k12

endif  &&jak=200

**************************************



IF (jak=90)
   stan4='ID'
   datum4='DATE(Year,Month,Day)'
      if NOT(Column_exist(datum4))
       datum4='Date'
      endif 
    rok_stM='Year'
    mes_stM_puv='Month'
    day_stM_puv='Day'
    remark4='Remark'
    value4='Value2'
   datum4_end=''
  sele_pom=SELECT()

     if Column_exist(rok_stM)
   DELETE ALL FOR year=0
     else
    delete all for year(&Datum4)=0
     endif
   PACK   

   *list of stations
   SELECT 90
   USE
     pomtab_run_90="controls\temp\pomtab_run_90.dbf"
       SET SAFETY off
    SELECT distinc ALLTRIM(&stan4) as &stan4 FROM DBF(sele_pom) INTO TABLE &pomtab_run_90
       SET SAFETY off
   USE
   SELECT 90
    USE &pomtab_run_90
  SCAN all  
    a_stan=ALLTRIM(&stan4)
     
    SELECT(sele_pom) 
   *doplneni nul, aby kazdy mesic mel zapis ...
   *DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
*  IF (k_add_0_each_month=.T.)  &&from day_pocdny.prg, co_delat=10
    CALCULATE MIN(&datum4) ALL FOR (ALLTRIM(&stan4)=ALLTRIM(a_stan)) TO dat_zac
    CALCULATE MAX(&datum4) ALL FOR (ALLTRIM(&stan4)=ALLTRIM(a_stan)) TO dat_kon
    FOR yy=YEAR(dat_zac) TO YEAR(dat_kon)
      FOR mm=1 TO 12
        FOR jj=1 TO 1  &&it is sufficient not to use AVG of begin and end date, i.e. jj=2
		           IF jj=1
		          datum_a='&datum4'
		             ELSE
		          datum_a='&datum4+(INT((&datum4_end-&datum4)/2))'  &&'CTOD(SYS(10, INT(VAL(SYS(11,&datum4))+VAL(SYS(11,&datum4_end))/2) )) '
		           ENDIF             
		       LOCATE FOR (ALLTRIM(&stan4)=ALLTRIM(a_stan))and(YEAR(&datum_a)=yy)and(MONTH(&datum_a)=mm)
*jeste osetrit, aby to nedaval od ledna , pokud se yacina v puli roce ...  a konec ...
		        IF NOT(FOUND())
		                          APPEND BLANK                           
		*DELETE                          
					                replace (stan4) with a_stan
					                  if ATC(',',datum4)>0
					                     *je to zadano jednotlive>
*					                     if (column_exist(rok_st2))
					                      replace (rok_stM) WITH yy
				                      replace (mes_stM_puv) WITH mm
				                      replace (day_stM_puv) WITH 1
*					                     endif 
					                  else                 
					               replace (datum4) with DATE(yy,mm,1)
					                  endif
*					                 replace (datum4_end) WITH &datum4 
*		     replace (remark4) WITH IIF(jj=1,'0 for missing month added','0 for mis.m. dateAVG')
*					               replace (pocdnu4) with 0  &&<<<<<<<<<<<<<<<<<<<
					               replace (value4)  with  -999  &&&
*					               replace (value4_avg)  with 0
*					                if column_exist(value4_ef)
*					               replace (value4_ef)  with 0
*					                endif                          
		        ENDIF     
        *jeste pripad, ze by prumer tech datumu ...
        ENDFOR jj
      ENDFOR mm
    ENDFOR      yy
*  ENDIF
   *DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

   SELECT 90   
 ENDSCAN &&a_stan
  SELECT 90
  USE
  SELECT(sele_pom)

ENDIF &&jak=90